Index: dll/shellext/shellbtrfs/shellbtrfs.rc
===================================================================
--- dll/shellext/shellbtrfs/shellbtrfs.rc	(révision 75772)
+++ dll/shellext/shellbtrfs/shellbtrfs.rc	(copie de travail)
@@ -7,7 +7,7 @@
 //
 // Generated from the TEXTINCLUDE 2 resource.
 //
-#include "afxres.h"
+#include "winres.h"
 
 /////////////////////////////////////////////////////////////////////////////
 #undef APSTUDIO_READONLY_SYMBOLS
@@ -27,18 +27,18 @@
 // TEXTINCLUDE
 //
 
-1 TEXTINCLUDE 
+1 TEXTINCLUDE
 BEGIN
     "resource.h\0"
 END
 
-2 TEXTINCLUDE 
+2 TEXTINCLUDE
 BEGIN
-    "#include ""afxres.h""\r\n"
+    "#include ""winres.h""\r\n"
     "\0"
 END
 
-3 TEXTINCLUDE 
+3 TEXTINCLUDE
 BEGIN
     "\r\n"
     "\0"
@@ -79,12 +79,12 @@
         BLOCK "080904b0"
         BEGIN
             VALUE "FileDescription", "WinBtrfs shell extension"
-            VALUE "FileVersion", "0.7"
+            VALUE "FileVersion", "1.0"
             VALUE "InternalName", "btrfs"
-            VALUE "LegalCopyright", "Copyright (c) Mark Harmstone 2016"
+            VALUE "LegalCopyright", "Copyright (c) Mark Harmstone 2016-17"
             VALUE "OriginalFilename", "shellbtrfs.dll"
             VALUE "ProductName", "WinBtrfs"
-            VALUE "ProductVersion", "0.7"
+            VALUE "ProductVersion", "1.0"
         END
     END
     BLOCK "VarFileInfo"
@@ -101,7 +101,7 @@
 
 IDD_PROP_SHEET DIALOGEX 0, 0, 235, 245
 STYLE DS_SETFONT | DS_FIXEDSYS | WS_CHILD | WS_DISABLED | WS_CAPTION
-CAPTION "s"
+CAPTION "Inode property sheet"
 FONT 8, "MS Shell Dlg", 400, 0, 0x0
 BEGIN
     LTEXT           "Subvolume:",IDC_STATIC,14,21,38,8
@@ -119,9 +119,9 @@
     LTEXT           "Read",IDC_STATIC,50,134,17,8
     LTEXT           "Write",IDC_STATIC,89,134,18,8
     LTEXT           "Execute",IDC_STATIC,129,134,30,8
-    CONTROL         "",IDC_USERR,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,54,146,16,10
-    CONTROL         "",IDC_GROUPR,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,54,157,16,10
-    CONTROL         "",IDC_OTHERR,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,54,167,16,10
+    CONTROL         "",IDC_USERR,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,54,147,16,10
+    CONTROL         "",IDC_GROUPR,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,54,158,16,10
+    CONTROL         "",IDC_OTHERR,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,54,168,16,10
     CONTROL         "",IDC_USERW,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,93,147,16,10
     CONTROL         "",IDC_GROUPW,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,93,158,16,10
     CONTROL         "",IDC_OTHERW,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,93,168,16,10
@@ -130,12 +130,18 @@
     CONTROL         "",IDC_OTHERX,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,135,168,16,10
     GROUPBOX        "Flags",IDC_STATIC,7,190,221,48
     CONTROL         "Disable Copy-on-Write",IDC_NODATACOW,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,14,204,86,10
-    LTEXT           "(blank)",IDC_SUBVOL,78,21,99,8
-    LTEXT           "(blank)",IDC_INODE,78,35,100,8
+    LTEXT           "(blank)",IDC_INODE,78,35,70,8
     LTEXT           "(blank)",IDC_TYPE,78,49,116,8
     CONTROL         "Compress",IDC_COMPRESS,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,14,218,46,10
     LTEXT           "Size on disk:",IDC_STATIC,14,63,61,8
     CONTROL         "%s (<a>Details</a>)",IDC_SIZE_ON_DISK,"SysLink",WS_TABSTOP,78,63,142,8
+    COMBOBOX        IDC_COMPRESS_TYPE,63,217,48,13,CBS_DROPDOWN | WS_VSCROLL | WS_TABSTOP
+    CONTROL         "Readonly subvolume",IDC_SUBVOL_RO,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,124,204,80,10
+    LTEXT           "(blank)",IDC_SUBVOL,78,21,70,8
+    PUSHBUTTON      "&Open as Admin",IDC_OPEN_ADMIN,151,21,70,14
+    CONTROL         "Set UID",IDC_SETUID,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,177,147,40,10
+    CONTROL         "Set GID",IDC_SETGID,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,177,158,40,10
+    CONTROL         "Sticky",IDC_STICKY,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,177,168,34,10
 END
 
 IDD_SIZE_DETAILS DIALOGEX 0, 0, 212, 85
@@ -154,7 +160,208 @@
     LTEXT           "(blank)",IDC_SIZE_LZO,63,46,142,8
 END
 
+IDD_VOL_PROP_SHEET DIALOGEX 0, 0, 235, 251
+STYLE DS_SETFONT | DS_FIXEDSYS | WS_CHILD | WS_DISABLED | WS_CAPTION
+CAPTION "s"
+FONT 8, "MS Shell Dlg", 400, 0, 0x0
+BEGIN
+    PUSHBUTTON      "Show &usage...",IDC_VOL_SHOW_USAGE,154,47,67,19
+    PUSHBUTTON      "&Balance...",IDC_VOL_BALANCE,154,105,67,19
+    PUSHBUTTON      "&Devices...",IDC_VOL_DEVICES,154,162,67,19
+    LTEXT           "UUID:",IDC_STATIC,7,15,20,8
+    LTEXT           "%02x%02x%02x%02x-%02x%02x-%02x%02x-%02x%02x-%02x%02x%02x%02x%02x%02x",IDC_UUID,32,15,294,8
+    GROUPBOX        "Usage",IDC_STATIC,7,31,221,53
+    LTEXT           "Show detailed information about internal filesystem usage. This is the equivalent to the command ""btrfs fi usage"" on Linux.",IDC_STATIC,14,44,131,33
+    GROUPBOX        "Balance",IDC_STATIC,7,87,221,53
+    LTEXT           "Balancing reads and rewrites data and metadata. It can be used to consolidate free space, as well as to convert between different RAID types.",IDC_STATIC,15,98,131,39
+    GROUPBOX        "Devices",IDC_STATIC,7,146,221,45
+    LTEXT           "Allows you to add disks or partitions to this filesystem, or remove those already present.",IDC_STATIC,14,159,131,30
+    GROUPBOX        "Scrub",IDC_STATIC,7,199,221,45
+    LTEXT           "Scrubbing verifies the data and metadata of a filesystem, and where possible will correct any errors.",IDC_STATIC,15,212,131,27
+    PUSHBUTTON      "&Scrub...",IDC_VOL_SCRUB,154,215,67,19
+END
 
+IDD_VOL_USAGE DIALOGEX 0, 0, 235, 242
+STYLE DS_SETFONT | DS_MODALFRAME | DS_FIXEDSYS | WS_POPUP | WS_CAPTION | WS_SYSMENU
+CAPTION "Volume usage"
+FONT 8, "MS Shell Dlg", 400, 0, 0x1
+BEGIN
+    DEFPUSHBUTTON   "OK",IDOK,62,221,50,14
+    PUSHBUTTON      "&Refresh",IDC_USAGE_REFRESH,124,221,50,14
+    EDITTEXT        IDC_USAGE_BOX,7,7,221,208,ES_MULTILINE | ES_AUTOHSCROLL | ES_READONLY | WS_VSCROLL
+END
+
+IDD_BALANCE_OPTIONS DIALOGEX 0, 0, 303, 138
+STYLE DS_SETFONT | DS_MODALFRAME | DS_FIXEDSYS | WS_POPUP | WS_CAPTION | WS_SYSMENU
+CAPTION "Balance options"
+FONT 8, "MS Shell Dlg", 400, 0, 0x1
+BEGIN
+    DEFPUSHBUTTON   "OK",IDOK,91,117,50,14
+    PUSHBUTTON      "Cancel",IDCANCEL,161,117,50,14
+    CONTROL         "&Profiles:",IDC_PROFILES,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,7,6,41,10
+    CONTROL         "Single",IDC_PROFILES_SINGLE,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,12,19,35,10
+    CONTROL         "DUP",IDC_PROFILES_DUP,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,12,30,29,10
+    CONTROL         "RAID0",IDC_PROFILES_RAID0,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,12,41,36,10
+    CONTROL         "RAID1",IDC_PROFILES_RAID1,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,12,52,36,10
+    CONTROL         "RAID10",IDC_PROFILES_RAID10,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,52,19,39,10
+    CONTROL         "RAID5",IDC_PROFILES_RAID5,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,52,30,36,10
+    CONTROL         "RAID6",IDC_PROFILES_RAID6,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,52,41,36,10
+    CONTROL         "&Usage:",IDC_USAGE,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,7,80,37,10
+    EDITTEXT        IDC_USAGE_START,7,94,19,14,ES_AUTOHSCROLL | ES_NUMBER
+    CONTROL         "",IDC_USAGE_START_SPINNER,"msctls_updown32",UDS_SETBUDDYINT | UDS_AUTOBUDDY | UDS_ARROWKEYS,25,94,11,14
+    EDITTEXT        IDC_USAGE_END,58,94,19,14,ES_AUTOHSCROLL | ES_NUMBER
+    CONTROL         "",IDC_USAGE_END_SPINNER,"msctls_updown32",UDS_SETBUDDYINT | UDS_AUTOBUDDY | UDS_ARROWKEYS,77,94,11,14
+    LTEXT           "% to",IDC_STATIC,39,97,16,8
+    CONTROL         "&Device:",IDC_DEVID,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,104,6,34,10
+    COMBOBOX        IDC_DEVID_COMBO,141,6,155,30,CBS_DROPDOWN | WS_VSCROLL | WS_TABSTOP
+    LTEXT           "%",IDC_STATIC,91,97,8,8
+    CONTROL         "Device &range:",IDC_DRANGE,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,104,19,59,10
+    EDITTEXT        IDC_DRANGE_END,159,32,40,14,ES_AUTOHSCROLL | ES_NUMBER
+    LTEXT           "to",IDC_STATIC,148,34,8,8
+    EDITTEXT        IDC_DRANGE_START,104,32,40,14,ES_AUTOHSCROLL | ES_NUMBER
+    CONTROL         "&Virtual range:",IDC_VRANGE,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,104,49,59,10
+    EDITTEXT        IDC_VRANGE_END,160,62,40,14,ES_AUTOHSCROLL | ES_NUMBER
+    LTEXT           "to",IDC_STATIC,148,64,8,8
+    EDITTEXT        IDC_VRANGE_START,104,62,40,14,ES_AUTOHSCROLL | ES_NUMBER
+    CONTROL         "&Limit:",IDC_LIMIT,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,104,80,33,10
+    EDITTEXT        IDC_LIMIT_START,104,94,19,14,ES_AUTOHSCROLL | ES_NUMBER
+    CONTROL         "",IDC_LIMIT_START_SPINNER,"msctls_updown32",UDS_SETBUDDYINT | UDS_AUTOBUDDY | UDS_ARROWKEYS,123,94,11,14
+    EDITTEXT        IDC_LIMIT_END,150,94,19,14,ES_AUTOHSCROLL | ES_NUMBER
+    CONTROL         "",IDC_LIMIT_END_SPINNER,"msctls_updown32",UDS_SETBUDDYINT | UDS_AUTOBUDDY | UDS_ARROWKEYS,169,94,11,14
+    LTEXT           "to",IDC_STATIC,139,97,8,8
+    CONTROL         "&Stripes:",IDC_STRIPES,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,210,19,40,10
+    EDITTEXT        IDC_STRIPES_START,210,32,19,14,ES_AUTOHSCROLL | ES_NUMBER
+    CONTROL         "",IDC_STRIPES_START_SPINNER,"msctls_updown32",UDS_SETBUDDYINT | UDS_AUTOBUDDY | UDS_ARROWKEYS,228,32,11,14
+    EDITTEXT        IDC_STRIPES_END,253,32,19,14,ES_AUTOHSCROLL | ES_NUMBER
+    CONTROL         "",IDC_STRIPES_END_SPINNER,"msctls_updown32",UDS_SETBUDDYINT | UDS_AUTOBUDDY | UDS_ARROWKEYS,272,32,11,14
+    LTEXT           "to",IDC_STATIC,242,35,8,8
+    CONTROL         "&Convert:",IDC_CONVERT,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,210,49,36,10
+    COMBOBOX        IDC_CONVERT_COMBO,248,49,48,30,CBS_DROPDOWN | WS_VSCROLL | WS_TABSTOP
+    CONTROL         "So&ft",IDC_SOFT,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,210,64,28,10
+END
+
+IDD_BALANCE DIALOGEX 0, 0, 254, 167
+STYLE DS_SETFONT | DS_MODALFRAME | DS_FIXEDSYS | WS_POPUP | WS_CAPTION | WS_SYSMENU
+CAPTION "Balance"
+FONT 8, "MS Shell Dlg", 400, 0, 0x1
+BEGIN
+    DEFPUSHBUTTON   "OK",IDOK,102,146,50,14
+    CONTROL         "",IDC_BALANCE_PROGRESS,"msctls_progress32",WS_BORDER,7,95,240,14
+    CONTROL         "&Data",IDC_DATA,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,7,7,30,10
+    CONTROL         "&Metadata",IDC_METADATA,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,7,28,45,10
+    CONTROL         "&System",IDC_SYSTEM,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,7,51,38,10
+    PUSHBUTTON      "Options...",IDC_DATA_OPTIONS,70,6,50,14
+    PUSHBUTTON      "Options...",IDC_METADATA_OPTIONS,70,26,50,14
+    PUSHBUTTON      "Options...",IDC_SYSTEM_OPTIONS,70,47,50,14
+    LTEXT           "Status",IDC_BALANCE_STATUS,8,80,239,8
+    PUSHBUTTON      "&Start balance",IDC_START_BALANCE,13,117,69,14
+    PUSHBUTTON      "&Pause / resume",IDC_PAUSE_BALANCE,93,117,69,14
+    PUSHBUTTON      "&Cancel balance",IDC_CANCEL_BALANCE,173,117,69,14
+END
+
+IDD_DEVICES DIALOGEX 0, 0, 318, 203
+STYLE DS_SETFONT | DS_MODALFRAME | DS_FIXEDSYS | WS_POPUP | WS_CAPTION | WS_SYSMENU
+CAPTION "Devices"
+FONT 8, "MS Shell Dlg", 400, 0, 0x1
+BEGIN
+    DEFPUSHBUTTON   "OK",IDOK,207,182,50,14
+    PUSHBUTTON      "Cancel",IDCANCEL,261,182,50,14
+    CONTROL         "",IDC_DEVLIST,"SysListView32",LVS_REPORT | LVS_ALIGNLEFT | WS_BORDER | WS_TABSTOP,7,7,304,144
+    PUSHBUTTON      "&Add device...",IDC_DEVICE_ADD,7,182,76,14
+    PUSHBUTTON      "&Refresh",IDC_DEVICE_REFRESH,7,159,76,14
+    PUSHBUTTON      "Remove &device",IDC_DEVICE_REMOVE,93,182,76,14
+    PUSHBUTTON      "Show &stats...",IDC_DEVICE_SHOW_STATS,235,159,76,14,WS_DISABLED
+    PUSHBUTTON      "Re&size...",IDC_DEVICE_RESIZE,149,159,76,14,WS_DISABLED
+END
+
+IDD_DEVICE_ADD DIALOGEX 0, 0, 261, 185
+STYLE DS_SETFONT | DS_MODALFRAME | DS_FIXEDSYS | WS_POPUP | WS_CAPTION | WS_SYSMENU
+CAPTION "Add device"
+FONT 8, "MS Shell Dlg", 400, 0, 0x1
+BEGIN
+    DEFPUSHBUTTON   "OK",IDOK,66,164,50,14
+    PUSHBUTTON      "Cancel",IDCANCEL,145,164,50,14
+    CONTROL         "",IDC_DEVICE_TREE,"SysTreeView32",TVS_HASBUTTONS | TVS_HASLINES | TVS_SHOWSELALWAYS | WS_BORDER | WS_HSCROLL | WS_TABSTOP,7,7,247,148
+END
+
+IDD_SCRUB DIALOGEX 0, 0, 254, 162
+STYLE DS_SETFONT | DS_MODALFRAME | DS_FIXEDSYS | WS_POPUP | WS_CAPTION | WS_SYSMENU
+CAPTION "Scrub"
+FONT 8, "MS Shell Dlg", 400, 0, 0x1
+BEGIN
+    DEFPUSHBUTTON   "OK",IDOK,102,141,50,14
+    CONTROL         "",IDC_SCRUB_PROGRESS,"msctls_progress32",WS_BORDER,7,95,240,14
+    LTEXT           "Status",IDC_SCRUB_STATUS,8,81,239,8
+    PUSHBUTTON      "&Start scrub",IDC_START_SCRUB,13,117,69,14
+    PUSHBUTTON      "&Pause / resume",IDC_PAUSE_SCRUB,93,117,69,14
+    PUSHBUTTON      "&Cancel scrub",IDC_CANCEL_SCRUB,173,117,69,14
+    EDITTEXT        IDC_SCRUB_INFO,7,7,240,69,ES_MULTILINE | ES_READONLY | WS_VSCROLL
+END
+
+IDD_DEVICE_STATS DIALOGEX 0, 0, 159, 113
+STYLE DS_SETFONT | DS_MODALFRAME | DS_FIXEDSYS | WS_POPUP | WS_CAPTION | WS_SYSMENU
+CAPTION "Device stats"
+FONT 8, "MS Shell Dlg", 400, 0, 0x1
+BEGIN
+    DEFPUSHBUTTON   "OK",IDOK,24,91,50,14
+    LTEXT           "Device %llx:",IDC_DEVICE_ID,7,7,40,8
+    LTEXT           "Write errors:",IDC_STATIC,7,21,79,8
+    LTEXT           "Read errors:",IDC_STATIC,7,34,79,8
+    LTEXT           "Flush errors:",IDC_STATIC,7,47,79,8
+    LTEXT           "Corruption errors:",IDC_STATIC,7,60,79,8
+    LTEXT           "Generation errors:",IDC_STATIC,7,73,79,8
+    RTEXT           "%llu",IDC_WRITE_ERRS,87,21,65,8
+    RTEXT           "%llu",IDC_READ_ERRS,87,34,65,8
+    RTEXT           "%llu",IDC_FLUSH_ERRS,87,47,65,8
+    RTEXT           "%llu",IDC_CORRUPTION_ERRS,87,60,65,8
+    RTEXT           "%llu",IDC_GENERATION_ERRS,87,73,65,8
+    PUSHBUTTON      "&Reset",IDC_RESET_STATS,85,91,50,14
+END
+
+IDD_RECV_PROGRESS DIALOGEX 0, 0, 311, 83
+STYLE DS_SETFONT | DS_MODALFRAME | DS_FIXEDSYS | WS_POPUP | WS_CAPTION | WS_SYSMENU
+CAPTION "Receiving subvolume"
+FONT 8, "MS Shell Dlg", 400, 0, 0x1
+BEGIN
+    PUSHBUTTON      "Cancel",IDCANCEL,130,62,50,14
+    CONTROL         "",IDC_RECV_PROGRESS,"msctls_progress32",WS_BORDER,7,33,297,24
+    LTEXT           "Receiving subvolume...",IDC_RECV_MSG,7,7,297,18
+END
+
+IDD_SEND_SUBVOL DIALOGEX 0, 0, 288, 149
+STYLE DS_SETFONT | DS_MODALFRAME | DS_FIXEDSYS | WS_POPUP | WS_CAPTION | WS_SYSMENU
+CAPTION "Send subvolume"
+FONT 8, "MS Shell Dlg", 400, 0, 0x1
+BEGIN
+    DEFPUSHBUTTON   "&Write",IDOK,83,128,50,14
+    PUSHBUTTON      "&Close",IDCANCEL,156,128,50,14
+    EDITTEXT        IDC_STREAM_DEST,57,7,166,14,ES_AUTOHSCROLL
+    LTEXT           "Stream:",IDC_STATIC,7,11,26,8
+    PUSHBUTTON      "&Browse...",IDC_BROWSE,231,7,50,14
+    LTEXT           "Select a destination for the subvolume stream.",IDC_SEND_STATUS,7,93,274,22
+    CONTROL         "Incremental",IDC_INCREMENTAL,"Button",BS_AUTOCHECKBOX | WS_TABSTOP,7,32,54,10
+    EDITTEXT        IDC_PARENT_SUBVOL,69,29,154,14,ES_AUTOHSCROLL | WS_DISABLED
+    PUSHBUTTON      "&Browse...",IDC_PARENT_BROWSE,231,29,50,14,WS_DISABLED
+    LTEXT           "Clone sources:",IDC_STATIC,7,52,46,8
+    LISTBOX         IDC_CLONE_LIST,69,50,154,36,LBS_NOINTEGRALHEIGHT | WS_VSCROLL | WS_TABSTOP
+    PUSHBUTTON      "&Add...",IDC_CLONE_ADD,231,50,50,14
+    PUSHBUTTON      "&Remove",IDC_CLONE_REMOVE,231,69,50,14,WS_DISABLED
+END
+
+IDD_RESIZE DIALOGEX 0, 0, 279, 133
+STYLE DS_SETFONT | DS_MODALFRAME | DS_FIXEDSYS | WS_POPUP | WS_CAPTION | WS_SYSMENU
+CAPTION "Resize device"
+FONT 8, "MS Shell Dlg", 400, 0, 0x1
+BEGIN
+    DEFPUSHBUTTON   "OK",IDOK,81,112,50,14
+    PUSHBUTTON      "Cancel",IDCANCEL,148,112,50,14
+    LTEXT           "Device %llx:",IDC_RESIZE_DEVICE_ID,18,21,238,8
+    LTEXT           "Current size: %s",IDC_RESIZE_CURSIZE,18,37,238,8
+    CONTROL         "",IDC_RESIZE_SLIDER,"msctls_trackbar32",TBS_BOTH | TBS_NOTICKS | WS_TABSTOP,7,74,265,24
+    LTEXT           "New size: %s",IDC_RESIZE_NEWSIZE,18,53,238,8
+END
+
+
 /////////////////////////////////////////////////////////////////////////////
 //
 // DESIGNINFO
@@ -161,7 +368,7 @@
 //
 
 #ifdef APSTUDIO_INVOKED
-GUIDELINES DESIGNINFO 
+GUIDELINES DESIGNINFO
 BEGIN
     IDD_PROP_SHEET, DIALOG
     BEGIN
@@ -178,6 +385,94 @@
         TOPMARGIN, 7
         BOTTOMMARGIN, 78
     END
+
+    IDD_VOL_PROP_SHEET, DIALOG
+    BEGIN
+        LEFTMARGIN, 7
+        RIGHTMARGIN, 228
+        TOPMARGIN, 7
+        BOTTOMMARGIN, 244
+    END
+
+    IDD_VOL_USAGE, DIALOG
+    BEGIN
+        LEFTMARGIN, 7
+        RIGHTMARGIN, 228
+        TOPMARGIN, 7
+        BOTTOMMARGIN, 235
+    END
+
+    IDD_BALANCE_OPTIONS, DIALOG
+    BEGIN
+        LEFTMARGIN, 7
+        RIGHTMARGIN, 296
+        TOPMARGIN, 7
+        BOTTOMMARGIN, 131
+    END
+
+    IDD_BALANCE, DIALOG
+    BEGIN
+        LEFTMARGIN, 7
+        RIGHTMARGIN, 247
+        TOPMARGIN, 7
+        BOTTOMMARGIN, 160
+    END
+
+    IDD_DEVICES, DIALOG
+    BEGIN
+        LEFTMARGIN, 7
+        RIGHTMARGIN, 311
+        TOPMARGIN, 7
+        BOTTOMMARGIN, 196
+    END
+
+    IDD_DEVICE_ADD, DIALOG
+    BEGIN
+        LEFTMARGIN, 7
+        RIGHTMARGIN, 254
+        TOPMARGIN, 7
+        BOTTOMMARGIN, 178
+    END
+
+    IDD_SCRUB, DIALOG
+    BEGIN
+        LEFTMARGIN, 7
+        RIGHTMARGIN, 247
+        TOPMARGIN, 7
+        BOTTOMMARGIN, 155
+    END
+
+    IDD_DEVICE_STATS, DIALOG
+    BEGIN
+        LEFTMARGIN, 7
+        RIGHTMARGIN, 152
+        TOPMARGIN, 7
+        BOTTOMMARGIN, 105
+    END
+
+    IDD_RECV_PROGRESS, DIALOG
+    BEGIN
+        LEFTMARGIN, 7
+        RIGHTMARGIN, 304
+        TOPMARGIN, 7
+        BOTTOMMARGIN, 76
+    END
+
+    IDD_SEND_SUBVOL, DIALOG
+    BEGIN
+        LEFTMARGIN, 7
+        RIGHTMARGIN, 281
+        TOPMARGIN, 7
+        BOTTOMMARGIN, 142
+    END
+
+    IDD_RESIZE, DIALOG
+    BEGIN
+        LEFTMARGIN, 7
+        RIGHTMARGIN, 272
+        TOPMARGIN, 7
+        BOTTOMMARGIN, 126
+    END
 END
 #endif    // APSTUDIO_INVOKED
 
@@ -194,10 +489,10 @@
 // String Table
 //
 
-STRINGTABLE 
+STRINGTABLE
 BEGIN
     IDS_NEW_SUBVOL_HELP_TEXT "Creates a new Btrfs subvolume."
-    IDS_NEW_SUBVOL          "New subvolume"
+    IDS_NEW_SUBVOL          "&New subvolume"
     IDS_NEW_SUBVOL_FILENAME "New subvolume"
     IDS_CREATE_SNAPSHOT     "Create snapshot"
     IDS_CREATE_SNAPSHOT_HELP_TEXT "Creates a snapshot of a Btrfs subvolume."
@@ -205,17 +500,17 @@
     IDS_PROP_SHEET_TITLE    "Btrfs properties"
     IDS_INODE_FILE          "File"
     IDS_INODE_DIR           "Directory"
-    IDS_INODE_CHAR          "Character device (major %llu, minor %u)"
+    IDS_INODE_CHAR          "Character device (major %llu, minor %llu)"
 END
 
-STRINGTABLE 
+STRINGTABLE
 BEGIN
-    IDS_INODE_BLOCK         "Block device (major %llu, minor %u)"
+    IDS_INODE_BLOCK         "Block device (major %llu, minor %llu)"
     IDS_INODE_FIFO          "FIFO"
     IDS_INODE_SOCKET        "Socket"
     IDS_INODE_SYMLINK       "Symbolic link"
     IDS_INODE_UNKNOWN       "Unknown inode type %x"
-    IDS_SET_INODE_INFO_ERROR "FSCTL_BTRFS_SET_INODE_INFO returned %08x"
+    IDS_CANNOT_FIND_DEVICE  "Cannot find device."
     IDS_SIZE_BYTE           "%s byte"
     IDS_SIZE_BYTES          "%s bytes"
     IDS_SIZE_KB             "%1.1f KB"
@@ -228,12 +523,231 @@
     IDS_INODE_CHAR_SIMPLE   "Character device"
 END
 
-STRINGTABLE 
+STRINGTABLE
 BEGIN
     IDS_INODE_BLOCK_SIMPLE  "Block device"
+    IDS_VOL_PROP_SHEET_TITLE "Btrfs"
     IDS_SIZE_LARGE          "%s (%s)"
+    IDS_SINGLE              "single"
+    IDS_DUP                 "DUP"
+    IDS_RAID0               "RAID0"
+    IDS_RAID1               "RAID1"
+    IDS_RAID10              "RAID10"
+    IDS_RAID5               "RAID5"
+    IDS_RAID6               "RAID6"
+    IDS_USAGE_DATA          "Data, %s: size: %s, used: %s"
+    IDS_USAGE_MIXED         "Data / metadata, %s: size: %s, used: %s"
+    IDS_USAGE_METADATA      "Metadata, %s: size: %s, used: %s"
+    IDS_USAGE_SYSTEM        "System, %s: size: %s, used: %s"
+    IDS_USAGE_UNALLOC       "Unallocated:"
+    IDS_UNKNOWN_DEVICE      "(unknown device %llu)"
 END
 
+STRINGTABLE
+BEGIN
+    IDS_USAGE_DEV_SIZE      "Device size:\t\t%s"
+    IDS_USAGE_DEV_ALLOC     "Device allocated:\t\t%s"
+    IDS_USAGE_DEV_UNALLOC   "Device unallocated:\t\t%s"
+    IDS_USAGE_DATA_RATIO    "Data ratio:\t\t%1.2f"
+    IDS_USAGE_METADATA_RATIO "Metadata ratio:\t\t%1.2f"
+    IDS_NO_BALANCE          "No balance is currently running."
+    IDS_SINGLE2             "Single"
+    IDS_DEVID_LIST          "%llu: %s"
+    IDS_BALANCE_RUNNING     "Balance is currently running (%llu out of %llu chunks processed, %1.1f%%)"
+    IDS_DRANGE_END_BEFORE_START "Device range end is before start."
+    IDS_VRANGE_END_BEFORE_START "Virtual range end is before start."
+    IDS_LIMIT_END_BEFORE_START "Limit end is before start."
+    IDS_STRIPES_END_BEFORE_START "Stripes end is before start."
+    IDS_USAGE_END_BEFORE_START "Usage end is before start."
+    IDS_ERROR               "Error"
+    IDS_BALANCE_COMPLETE    "Balance completed successfully."
+END
+
+STRINGTABLE
+BEGIN
+    IDS_BALANCE_PAUSED      "Balance is currently paused (%llu out of %llu chunks processed, %1.1f%%)"
+    IDS_BALANCE_CANCELLED   "Balance cancelled."
+    IDS_DEVLIST_ID          "ID"
+    IDS_DEVLIST_DESC        "Description"
+    IDS_DEVLIST_READONLY    "Read-only"
+    IDS_DEVLIST_SIZE        "Size"
+    IDS_DEVLIST_READONLY_YES "Yes"
+    IDS_DEVLIST_READONLY_NO "No"
+    IDS_DEVLIST_ALLOC       "Allocated"
+    IDS_DEVLIST_ALLOC_PC    "%"
+    IDS_BALANCE_RUNNING_REMOVAL
+                            "Currently removing device %llu (%llu out of %llu chunks processed, %1.1f%%)"
+    IDS_BALANCE_PAUSED_REMOVAL
+                            "Removal of device %llu paused (%llu out of %llu chunks processed, %1.1f%%)"
+    IDS_BALANCE_CANCELLED_REMOVAL "Device removal cancelled."
+    IDS_BALANCE_COMPLETE_REMOVAL "Device removal completed successfully."
+    IDS_PARTITION           "Partition %u"
+    IDS_WHOLE_DISK          "Whole disk"
+END
+
+STRINGTABLE
+BEGIN
+    IDS_CANNOT_REMOVE_RAID  "The current RAID levels do not allow this device to be removed. You must do a conversion balance before you will be able to proceed."
+    IDS_REMOVE_DEVICE_CONFIRMATION
+                            "Are you sure that you want to remove device %s, %s?"
+    IDS_CONFIRMATION_TITLE  "Confirmation"
+    IDS_ADD_DEVICE_CONFIRMATION
+                            "Are you sure that you want to add this device?"
+    IDS_ADD_DEVICE_CONFIRMATION_FS
+                            "Are you sure that you want to add this device? It already appears to contain a filesystem (%s)."
+    IDS_BALANCE_FAILED      "Balance failed (error %08x, %s)"
+    IDS_BALANCE_FAILED_REMOVAL "Device removal failed (error %08x, %s)"
+    IDS_DISK_NUM            "Disk %u"
+    IDS_DISK_PART_NUM       "Disk %u, partition %u"
+    IDS_NO_SCRUB            "Scrub not running."
+    IDS_SCRUB_RUNNING       "Scrub currently running (%llu out of %llu chunks processed, %1.1f%%)"
+    IDS_SCRUB_FINISHED      "Scrub finished."
+    IDS_SCRUB_PAUSED        "Scrub paused (%llu out of %llu chunks processed, %1.1f%%)"
+    IDS_SCRUB_MSG_STARTED   "Scrub started at %s %s."
+    IDS_SCRUB_MSG_RECOVERABLE_DATA
+                            "Recovered from data checksum error at %llx on device %llx."
+    IDS_SCRUB_MSG_RECOVERABLE_METADATA
+                            "Recovered from metadata checksum error at %llx on device %llx."
+END
+
+STRINGTABLE
+BEGIN
+    IDS_SCRUB_MSG_UNRECOVERABLE_DATA
+                            "Unrecoverable data checksum error at %llx on device %llx (%.*s, offset %llx)"
+    IDS_SCRUB_MSG_UNRECOVERABLE_DATA_SUBVOL
+                            "Unrecoverable data checksum error at %llx on device %llx (subvol %llx, %.*s, offset %llx)"
+    IDS_SCRUB_MSG_UNRECOVERABLE_METADATA
+                            "Unrecoverable metadata checksum error at %llx on device %llx (root %llx, level %x)"
+    IDS_SCRUB_MSG_UNRECOVERABLE_METADATA_FIRSTITEM
+                            "Unrecoverable metadata checksum error at %llx on device %llx (root %llx, level %x, first item %llx,%x,%llx)"
+    IDS_SCRUB_MSG_FINISHED  "Scrub finished at %s %s."
+    IDS_SCRUB_MSG_SUMMARY   "Scrubbed %s in %llu seconds (%s/s)."
+    IDS_BALANCE_SCRUB_RUNNING "Cannot start balance while scrub running."
+    IDS_SCRUB_BALANCE_RUNNING "Cannot start scrub while balance running."
+    IDS_SCRUB_MSG_SUMMARY_ERRORS_RECOVERABLE "Recovered from %llu error(s)."
+    IDS_SCRUB_MSG_SUMMARY_ERRORS_UNRECOVERABLE
+                            "%llu unrecoverable error(s) found."
+    IDS_SCRUB_FAILED        "Scrub failed with error %08x."
+    IDS_LOCK_FAILED         "Unable to lock volume: error %08x. Make sure that there are no files open, and that you have closed any Explorer windows."
+    IDS_SCRUB_MSG_RECOVERABLE_PARITY
+                            "Recovered from parity error at %llx on device %llx."
+    IDS_COMPRESS_ANY        "(any)"
+    IDS_COMPRESS_ZLIB       "Zlib"
+    IDS_COMPRESS_LZO        "LZO"
+END
+
+STRINGTABLE
+BEGIN
+    IDS_STANDALONE_PROPSHEET_TITLE "Inode property sheet"
+    IDS_REFLINK_PASTE       "Ref&link Paste"
+    IDS_REFLINK_PASTE_HELP  "Do a lightweight copy of files using reference counting."
+    IDS_RECV_SUBVOL         "Re&ceive subvolume..."
+    IDS_RECV_SUBVOL_HELP    "Recreate a previously exported subvolume."
+    IDS_RECV_CANT_OPEN_FILE "%S: Couldn't open %s (error %u, %s)."
+    IDS_RECV_READFILE_FAILED "ReadFile failed (error %u, %s)."
+    IDS_OUT_OF_MEMORY       "Out of memory."
+    IDS_RECV_UNKNOWN_COMMAND "Unrecognized command %u encountered."
+    IDS_RECV_CANT_OPEN_PATH "Couldn't open path %s (error %u, %s)."
+    IDS_RECV_RTLUTF8TOUNICODEN_FAILED "RtlUTF8ToUnicodeN returned %08x (%s)."
+    IDS_RECV_CREATE_SUBVOL_FAILED
+                            "FSCTL_BTRFS_CREATE_SUBVOL returned %08x (%s)."
+    IDS_RECV_MISSING_PARAM  "%S: could not find %s parameter."
+    IDS_RECV_SHORT_PARAM    "%S: length of parameter %s was %u, expected %u."
+    IDS_RECV_MKNOD_FAILED   "FSCTL_BTRFS_MKNOD returned %08x (%s)."
+    IDS_RECV_SET_REPARSE_POINT_FAILED
+                            "FSCTL_SET_REPARSE_POINT returned %08x (%s)."
+END
+
+STRINGTABLE
+BEGIN
+    IDS_RECV_MOVEFILE_FAILED "MoveFile (%s -> %s) failed (error %u, %s)."
+    IDS_RECV_SETFILEPOINTER_FAILED "SetFilePointer failed (error %u, %s)."
+    IDS_RECV_WRITEFILE_FAILED "WriteFile failed (error %u, %s)."
+    IDS_RECV_CREATEHARDLINK_FAILED
+                            "CreateHardLink (%s -> %s) failed (error %u, %s)."
+    IDS_RECV_SETENDOFFILE_FAILED "SetEndOfFile failed (error %u, %s)."
+    IDS_RECV_CANT_CREATE_FILE "Couldn't create %s (error %u, %s)."
+    IDS_RECV_SETFILEINFO_FAILED
+                            "SetFileInformationByHandle failed (error %u, %s)."
+    IDS_RECV_SETINODEINFO_FAILED
+                            "FSCTL_BTRFS_SET_INODE_INFO returned %08x (%s)."
+    IDS_RECV_SUCCESS        "Received 1 subvolume successfully."
+    IDS_RECV_BUTTON_OK      "OK"
+    IDS_RECV_SETFILEATTRIBUTES_FAILED
+                            "SetFileAttributes failed (error %u, %s)."
+    IDS_RECV_GETFILEATTRIBUTES_FAILED
+                            "GetFileAttributes failed (error %u, %s)."
+    IDS_RECV_CSUM_ERROR     "Checksum error."
+    IDS_RECV_NOT_A_SEND_STREAM "File was not a send stream."
+    IDS_RECV_UNSUPPORTED_VERSION "Unsupported version %u."
+    IDS_RECV_SETEAFILE_FAILED "NtSetEaFile returned %08x (%s)."
+END
+
+STRINGTABLE
+BEGIN
+    IDS_RECV_RECEIVED_SUBVOL_FAILED
+                            "FSCTL_BTRFS_RECEIVED_SUBVOL returned %08x (%s)."
+    IDS_RECV_SETSECURITYOBJECT_FAILED
+                            "NtSetSecurityObject returned %08x (%s)."
+    IDS_RECV_SETXATTR_FAILED "FSCTL_BTRFS_SET_XATTR returned %08x (%s)."
+    IDS_RECV_CREATETHREAD_FAILED "CreateThread failed (error %u, %s)."
+    IDS_RECV_FILE_TRUNCATED "File was truncated."
+    IDS_RECV_RESERVE_SUBVOL_FAILED
+                            "FSCTL_BTRFS_RESERVE_SUBVOL returned %08x (%s)."
+    IDS_RECV_CANCELLED      "Receiving cancelled."
+    IDS_RECV_CANT_FIND_PARENT_SUBVOL "Could not find parent subvolume."
+    IDS_RECV_FIND_SUBVOL_FAILED "FSCTL_BTRFS_FIND_SUBVOL returned %08x (%s)."
+    IDS_RECV_CREATE_SNAPSHOT_FAILED
+                            "FSCTL_BTRFS_CREATE_SNAPSHOT returned %08x (%s)."
+    IDS_RECV_GETVOLUMEPATHNAME_FAILED
+                            "GetVolumePathName failed (error %u, %s)."
+    IDS_RECV_DELETEFILE_FAILED "DeleteFile failed for %s (error %u, %s)."
+    IDS_RECV_REMOVEDIRECTORY_FAILED
+                            "RemoveDirectory failed for %s (error %u, %s)."
+    IDS_RECV_CANT_FIND_CLONE_SUBVOL "Could not find clone subvolume."
+    IDS_RECV_GETFILESIZEEX_FAILED "GetFileSizeEx failed (error %u, %s)."
+    IDS_RECV_DUPLICATE_EXTENTS_FAILED
+                            "FSCTL_DUPLICATE_EXTENTS_TO_FILE returned %08x (%s)."
+END
+
+STRINGTABLE
+BEGIN
+    IDS_RECV_SUCCESS_PLURAL "Received %u subvolumes successfully."
+    IDS_SEND_SUBVOL         "&Send subvolume..."
+    IDS_SEND_SUBVOL_HELP    "Exports a subvolume so that it can be recreated on another volume."
+    IDS_SEND_CANT_OPEN_FILE "Error opening file %s (error %u, %s)."
+    IDS_SEND_CANT_OPEN_DIR  "Error opening directory %s (error %u, %s)."
+    IDS_SEND_FSCTL_BTRFS_SEND_SUBVOL_FAILED
+                            "FSCTL_BTRFS_SEND_SUBVOL returned error %08x (%s)."
+    IDS_SEND_FSCTL_BTRFS_READ_SEND_BUFFER_FAILED
+                            "FSCTL_BTRFS_READ_SEND_BUFFER returned error %08x (%s)."
+    IDS_SEND_SUCCESS        "Stream written successfully."
+    IDS_SEND_WRITEFILE_FAILED "Writing to file failed (error %u, %s)."
+    IDS_SEND_GET_FILE_INFO_FAILED
+                            "GetFileInformationByHandle failed (error %u, %s)."
+    IDS_SEND_NOT_READONLY   "Subvolume not readonly."
+    IDS_NOT_SUBVOL          "Directory was not a subvolume."
+    IDS_GET_FILE_IDS_FAILED "FSCTL_BTRFS_GET_FILE_IDS returned error %08x (%s)."
+    IDS_SHPARSEDISPLAYNAME_FAILED "SHParseDisplayName failed."
+    IDS_SHGETPATHFROMIDLIST_FAILED "SHGetPathFromIDList failed."
+    IDS_SEND_PARENT_NOT_READONLY "Parent subvolume not readonly."
+END
+
+STRINGTABLE
+BEGIN
+    IDS_SEND_CANCEL         "&Cancel"
+    IDS_SEND_WRITING        "Writing..."
+    IDS_MISSING             "(missing)"
+    IDS_RESIZE_SUCCESSFUL   "Device %llx successfully resized to %s."
+    IDS_BALANCE_RUNNING_SHRINK
+                            "Currently shrinking device %llu (%llu out of %llu chunks processed, %1.1f%%)"
+    IDS_BALANCE_PAUSED_SHRINK
+                            "Shrinking of device %llu paused (%llu out of %llu chunks processed, %1.1f%%)"
+    IDS_BALANCE_CANCELLED_SHRINK "Device shrinking cancelled."
+    IDS_BALANCE_COMPLETE_SHRINK "Device successfully shrunk."
+    IDS_BALANCE_FAILED_SHRINK "Device shrinking failed (error %08x, %s)"
+END
+
 #endif    // English (U.K.) resources
 /////////////////////////////////////////////////////////////////////////////
 
